#!/bin/sh
#
#	Copyright (c)2001 Grumbler
#
# $Id: trafd.sh,v 1.2 2002/10/18 03:28:28 stas_degteff Exp $
#
#
# if $1=='start': start of the network traffic collector
# if $1=='stop' : dump all records to /var/tmp/trafd.$iface
#		and shutdown network traffic collector ('kill')
#
# !!! ALERT !!!
# set the "IFF_LISTEN" enviroment variable to REAL interface name
#

. /etc/rc.conf

# Interface for traffic accounting

if [ "${IFF_LISTEN}" ] ; then
	ifaces="${IFF_LISTEN}"
else
#	iface="`/sbin/ifconfig -lu | /usr/bin/sed s/\ .*//`"  # 1st iface in list
	ifaces="`/sbin/ifconfig -lu | /usr/bin/sed s/lo0//`"	# all ifaces except loopback (lo0)
fi

if [ ! "${ifaces}" ] ; then
	/bin/echo "Not an interface for listen!"
	/bin/echo `/bin/date +"%b %e %H:%M:%S"` `/bin/hostname -s` trafd.sh: Not an interface for listen!
	exit -1
fi


WHERE_PID=/var/run/trafd.
LOG_FILE=/var/log/trafd.log

case $1 in
start)
	for iface in $ifaces; do
	  /usr/local/sbin/trafd -pri $iface && /bin/echo " trafd (${iface}) "
	  if [ $? = 0 ]; then
	    /bin/echo `/bin/date +"%b %e %H:%M:%S"` `/bin/hostname -s` trafd.sh: '('$iface')' started >> $LOG_FILE
	  fi
	done
        ;;
stop)
	for iface in $ifaces; do
	  PID_FILE=$WHERE_PID$iface
	  if [ -f $PID_FILE ]; then
	    PID="`cat $PID_FILE`"
	    /bin/kill -QUIT ${PID}
	    if [ $? = 0 ]; then
		/bin/echo `/bin/date +"%b %e %H:%M:%S"` `/bin/hostname -s` trafd.sh: '('$iface')' signaling to shutdown >> $LOG_FILE
	    fi
	  else
	    if [ ! -d $LOG_FILE -a -w $LOG_FILE ]; then
		/bin/echo "`/bin/date +"%b %e %H:%M:%S"` `/bin/hostname -s` trafd.sh: (stop) error: $PID_FILE not found" | /usr/bin/tee -a $LOG_FILE
	    else
		/bin/echo "`/bin/date +"%b %e %H:%M:%S"` `/bin/hostname -s` trafd.sh: (stop) warning: $PID_FILE not found"
	    fi
	  fi
	done
        ;;
*)
        /bin/echo "Usage: `/usr/bin/basename $0` {start|stop}" >&2
        exit 64
        ;;
esac

exit 0

